.bios
.page 2
.rom
.start DEBUT

NAMTBL equ 1800h
SPRTBL equ 3800h
SPRATR equ 1b00h

DEBUT:
call DISSCR
ld hl,0f3e9h
ld [hl],15
inc hl
ld [hl],0
inc hl
ld [hl],0
call INIGRP
ld bc,06201h
call WRTVDP

ld hl,NAMTBL
ld bc,768
xor a
call FILVRM

ld hl,ATR_INITIAL
ld de,SPRITES
ld bc,8
ldir
;
; Defininitions des sprites
;
        ld      hl,SPR_DEF	;On charge en HL le dbut de l'endroit de la mmoire ou sont stock les patrons des sprites
        ld      de,SPRTBL	;On indique o on veut les mettre (table  des patrons des sprite  partir de 0) 
        ld      bc,6*4*8	;on boucle sur 6 sprites de 4 carrs de 8 octets
        call    LDIRVM	;on copie HL en ROM sur DE en VRAM, HL=HL+1, DE=DE+1, BC=BC-1 jusqu' ce que BC=0.

call ENASCR

LOOP:

	xor a			; mise  0 de l'accu (a)	
	call CHOIX_SPRITE	; mise  la valeur par dfaut de l'aspect du vaisseau
;
; DEPLACEMENT 
;
xor 	a		; mise  0 de l'accu (a)
call 	GTSTCK		; test du pad clavier (0)
push	AF		; Sauvegarde de a dans la pile
;
;EST
;
ld 	HL,STK_POE	; HL pointe vers les 3 positions ou les prite va  droite (2,3,4)
ld 	bc,3		; BC 3 on boucle sur 3 tours voir instruction suivante:
cpir			; test de a avec l'adresse point par HL puis HL=HL+1 et BC=BC-1
			; jusqu' ce que BC=0 (fin de la boucle) :-) je viens de dcouvrir cette instruction!
JR NZ,@@WEST 		; si pas d'galit entre a et les 3 valeurs point par HL on passe  la suite
			; sinon on dplace le sprite
	ld a,[SPRITES+1]  ; a=position en x du sprite 1
	cp 240		; a=240?
	jr z,@@NORTH	; oui donc on passe direct au dplacement vertical
	inc a		; sinon a=a+2
	inc a
	ld [SPRITES+1],a	; remise de a+2 dans x du sprite1
	ld [SPRITES+5],a  ; puis dans x du sprite2 car il sesuivent en permanence ;-)
	jp @@NORTH	; puis on passe direct au dplacement vertical
;
;OUEST
;	
@@WEST:
ld 	HL,STK_POW
ld 	bc,3
cpir
JR NZ,@@NORTH 
	ld a,[SPRITES+1]
	cp 0
	jr z,@@NORTH
	dec a
	dec a
	ld [SPRITES+1],a
	ld [SPRITES+5],a
;
;NORD
;	
@@NORTH:
pop	AF
ld 	HL,STK_PON
ld 	bc,3
cpir
JR NZ,@@SOUTH 
	ld a,8
	call CHOIX_SPRITE
	ld a,[SPRITES]
	cp 0
	jr z,@@END
	dec a
	dec a
	ld [SPRITES],a
	ld [SPRITES+4],a
	JP @@END
;
;SUD
;	
@@SOUTH:
ld 	HL,STK_POS
ld 	bc,3
cpir
JR NZ,@@END
	ld a,16
	call CHOIX_SPRITE
	ld a,[SPRITES]
	cp 176
	jr z,@@END
	ld a,[SPRITES]
	inc a
	inc a
	ld [SPRITES],a
	ld [SPRITES+4],a	

@@END:
call DUMP
jp LOOP


nop
ret


DUMP:
halt
ld hl,SPRITES
ld de,SPRATR
ld bc,8
call LDIRVM
ret

CHOIX_SPRITE:
	ld [SPRITES+2],a
	add a,4
	ld [SPRITES+6],a
	cp 12
	jr nz,@@ROUGE
	ld a,4
	jp @@COULEUR
@@ROUGE:
	ld a,8
@@COULEUR:
	ld [SPRITES+7],a
ret

ATR_INITIAL:
	db 88,120,0,15
	db 88,120,4,8
STK_POE:
	db 2,3,4
STK_POW:
	db 6,7,8	
STK_PON:
	db 8,1,2
STK_POS:
	db 4,5,6	

SPR_DEF:
;SPR_NEM1	=	sprite0 
    db  000h,080h,0e0h,070h,07fh,07fh,0bfh,0bfh,0bfh,078h,0e0h,000h,000h,000h,000h,000h
    db  000h,000h,000h,000h,000h,088h,0ffh,0f8h,000h,000h,000h,000h,000h,000h,000h,000h
;SPR_NEM2	=	sprite1*4		= 4 
    db  000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
    db  000h,000h,000h,000h,0c0h,070h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
;SPR_UP1	=	sprite2*4		= 8
    db 000h,080h,0e0h,070h,0ffh,01fh,001h,000h,000h,000h,000h,000h,000h,000h,000h,000h
    db 000h,000h,000h,000h,080h,0f0h,0ffh,000h,000h,000h,000h,000h,000h,000h,000h,000h
;SPR_UP2	=	sprite3*4		= 12
    db 000h,000h,000h,000h,000h,0e0h,0feh,07fh,03fh,01eh,018h,000h,000h,000h,000h,000h
    db 000h,000h,000h,000h,000h,000h,000h,0fch,0f0h,000h,000h,000h,000h,000h,000h,000h
;SPR_DOWN1	=	sprite4*4		= 16
    db 000h,000h,0b0h,0fch,07fh,07fh,0bfh,0bfh,0bfh,07fh,078h,0e0h,000h,000h,000h,000h
    db 000h,000h,000h,000h,080h,018h,08fh,0fch,0e0h,000h,000h,000h,000h,000h,000h,000h
;SPR_DOWN1	=	sprite5*4		= 20
    db 000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h,000h
    db 000h,000h,000h,000h,000h,0e0h,070h,000h,000h,000h,000h,000h,000h,000h,000h,000h

.page 3

SPRITES:
ds 8